unit ConvexHullUnit;

interface

function myconvex(numpoints: integer): boolean; stdcall;

implementation

uses
  Dlist,sec;

type
  Tx = double;
  Tnode=record
          x,y,angle: Tx;
          incl: boolean;
        end;
  TnodeA=array of Tnode;

procedure Pconvex(var list: TnodeA; var imax: integer);
var
  x0,y0: Tx;
  i,j: integer;
  DL: TDList;

  procedure QuickSort(iLo, iHi: longInt);
  var
    Lo,Hi: longInt;
    Mid: Tx;
    tt: Tnode;
  begin
    Lo:= iLo;
    Hi:= iHi;
    Mid:= list[(Lo + Hi) div 2].angle;
    repeat
      while list[Lo].angle<Mid do Inc(Lo);
      while list[Hi].angle>Mid do Dec(Hi);
      if Lo<=Hi then
      begin
        tt:= list[Lo]; list[Lo]:= list[Hi]; list[Hi]:= tt;
        Inc(Lo);
        Dec(Hi);
      end;
    until Lo>Hi;
    if Hi>iLo then QuickSort(iLo,Hi);
    if Lo<iHi then QuickSort(Lo,iHi);
  end;

  procedure QuickSort2(iLo, iHi: longInt);
  var
    Lo,Hi: longInt;
    Midx,Midy: Tx;
    tt: Tnode;
  begin
    Lo:= iLo;
    Hi:= iHi;
    Midx:= list[(Lo + Hi) div 2].x;
    Midy:= list[(Lo + Hi) div 2].y;
    repeat
      while (list[Lo].x<Midx) or ((list[Lo].x=Midx) and (list[Lo].y<Midy)) do Inc(Lo);
      while (list[Hi].x>Midx) or ((list[Hi].x=Midx) and (list[Hi].y>Midy)) do Dec(Hi);
      if Lo<=Hi then
      begin
        tt:= list[Lo]; list[Lo]:= list[Hi]; list[Hi]:= tt;
        Inc(Lo);
        Dec(Hi);
      end;
    until Lo>Hi;
    if Hi>iLo then QuickSort2(iLo,Hi);
    if Lo<iHi then QuickSort2(Lo,iHi);
  end;

  function fk(a,b,c: integer): integer;
  var
    t: Tx;
  begin
    t:= (list[a].y-list[b].y)*list[c].x+
        (list[b].x-list[a].x)*list[c].y+
        (list[a].x*list[b].y-list[b].x*list[a].y);
    if (a=b) or (a=c) or (b=c) or (t=0) then result:= 0 else
    if t<0 then result:= 1 else result:= -1;
  end;

begin
  {sort according to x}
  quicksort2(1,imax);

  // remove duplicates
  i:= 1;
  repeat
    if (list[i].x=list[i+1].x) and (list[i].y=list[i+1].y) then
    begin
      for j:= i+1 to imax-1 do list[j]:= list[j+1];
      dec(imax);
    end else inc(i);
  until i=imax-1;

  {find center}
  x0:= 0; for i:= 1 to imax do x0:=x0+list[i].x; x0:= x0/imax;
  y0:= 0; for i:= 1 to imax do y0:=y0+list[i].y; y0:= y0/imax;

  {calculate angles}
  for i:= 1 to imax do with list[i] do
  begin
    if (x=x0) then
    begin
      if y>y0 then angle:= pi/2 else
      if y<y0 then angle:= 3*pi/2 else angle:= 0;
    end else
    begin
      angle:= arctan((y-y0)/(x-x0));
      if x<x0 then angle:= angle+pi; {2+3. quadrant}
      if (y<y0) and (x>x0) then angle:= angle+2*pi; {4. quadrant}
    end;
  end;

  {sort according to angle}
  quicksort(1,imax);

  {A.A. Melkman's algorithm}
  DL:= TDList.create;
  if fk(1,2,3)>0 then
  begin
    DL.push(1); DL.push(2);
  end else
  begin
    DL.push(2); DL.push(1);
  end;
  DL.push(3);
  DL.insert(3);

  i:= 4;
  repeat
    while (i<=imax) and (fk(DL.first,DL.nfirst,i)>=0) and
          (fk(DL.nlast,DL.last,i)>=0) do inc(i);
    if i<=imax then
    begin
      while fk(DL.nlast,DL.last,i)<=0 do DL.pop;
      DL.push(i);

      while fk(DL.first,DL.nfirst,i)<=0 do DL.remove;
      DL.insert(i);
    end;
  until i>imax;

  {all nodes are out}
  for i:= 1 to imax do list[i].incl:= false;
  {some are in}
  while not DL.empty do list[DL.pop].incl:= true;
  DL.destroy;
end;

function myconvex;
var
  t: textfile;
  v: TnodeA;
  no1,i,imax: integer;
begin
  setlength(v,numpoints+1);
  assignfile(t,'input.txt');
  reset(t);
  i:= 0;
  while not eof(t) do
  begin
    inc(i);
    readln(t,v[i].x,v[i].y);
  end;
  closefile(t);
  imax:= i;

  Pconvex(v,imax);

  {tl antal punkter}
  no1:= 0;
  for i:= 1 to imax do if v[i].incl then
    if no1=0 then no1:= i;

  {lav output}
  assignfile(t,'output.txt');
  rewrite(t);
  writeln(t,'x y');
  for i:= 1 to imax do if v[i].incl then writeln(t,v[i].x,' ',v[i].y);
  writeln(t,v[no1].x,' ',v[no1].y);
  closefile(t);
  result:= true;
  finalize(v);
end;

end.
